define({"0":{y:0,u:"../Content/Swarm/about.html",l:-1,t:"How to use this guide | Swarm",i:0.0015687529820253,a:"This manual provides information on performing code reviews and collaboration with Helix Swarm (version 2022.1.3, released in June 2022)."},"1":{y:0,u:"../Content/Swarm/swarm.html",l:-1,t:"About Helix Swarm",i:0.0015687529820253,a:"Swarm enables collaboration and code review for teams using Helix Core Server, helping ship quality software faster. Swarm is a collaboration tool for all types of intellectual property. It unites teams to foster brainstorming, formalize content reviews, and keep projects moving forward. ..."},"2":{y:0,u:"../Content/Swarm/whatsnew.html",l:-1,t:"What’s new",i:0.00175525370120455,a:"This section provides a summary of the notable changes in Swarm for the 2022.1.3 release. Full details are available in the distribution\u0027s RELNOTES.txt file.  Major new functionality New Swarm review page (preview) The new Swarm review page introduces some of our most requested features such as ..."},"3":{y:0,u:"../Content/Swarm/chapter.quickstart.html",l:-1,t:"Quickstart",i:0.00167132798942156,a:"Quickstart Often, the best way to learn how software works is to try it. If the interface is sufficiently discoverable, you may not need to refer to documentation much, or at all. Sometimes, you just need to see the required steps to complete a task; that\u0027s what this chapter is all about."},"4":{y:0,u:"../Content/Swarm/quickstart.quick_reference.html",l:-1,t:"Swarm quick reference",i:0.00167132798942156,a:"Swarm quick reference This section contains quick reference guides to help to familiarize you with Swarm: "},"5":{y:0,u:"../Content/Swarm/quickstart.main_and_project_menus_quick_reference.html",l:-1,t:"Menu quick reference",i:0.0016513212360541,a:"The Header, Main, and Project menus are used to quickly navigate around Swarm.  Header  click to display a list reviews that need your attention, see the  My Dashboard  page. Search box: search for projects, groups, users, and files that match your search string.   click to view the Swarm help.  Log ..."},"6":{y:0,u:"../Content/Swarm/quickstart_quick_reference_quick_urls.html",l:-1,t:"Quick URLs quick reference",i:0.0015687529820253,a:"Swarm handles URLs intelligently to reduce the amount of information you need to enter to quickly locate what you are looking for:  Enter a URL in the following format: https://myswarm.url/\u003cidentifier\u003e Swarm checks the \u003cidentifier\u003e and redirects you to the first match it finds. Swarm checks for the ..."},"7":{y:0,u:"../Content/Swarm/quickstart.dashboard_quick_reference.html",l:-1,t:"My Dashboard page quick reference",i:0.0109711134298893,a:"The purpose of the dashboard is to allow you to focus on reviews that need to be done, so that other users are not blocked. The dashboard lists  the most recently modified reviews first, and shows your role in the review. Since it is tied to the logged in user, My Dashboard is only populated if you ..."},"8":{y:0,u:"../Content/Swarm/quickstart-global_dashboard_quick_reference.html",l:-1,t:"Global dashboard page quick reference",i:0.00272832743557281,a:"Global dashboard is only available if your Swarm administrator has configured Swarm to connect to more than one Helix Core Server instance. The purpose of the global dashboard is to allow you to focus on reviews that need to be done, so that other users are not blocked. The global dashboard lists ..."},"9":{y:0,u:"../Content/Swarm/quickstart.review_list_quick_reference.html",l:-1,t:"Reviews list page quick reference",i:0.0104228903596637,a:"The Reviews page lists code reviews that are in progress, and code reviews that are complete. Log in to Swarm. Click Reviews in the  main  menu. Jump directly to a specific area of the Reviews page using the following links:  Opened and Closed tabs Review filters Reviews list content Opened and ..."},"10":{y:0,u:"../Content/Swarm/quickstart.review_page_overview.html",l:-1,t:"Review page quick reference",i:0.00175525370120455,a:"The new Swarm review page is now available as a preview. The new Swarm review page is described in this documentation.  By default, Swarm opens the original  review page when you first start Swarm 2022.1. To access the review page preview, use the Preview toggle switch at the top of the review page. ..."},"11":{y:0,u:"../Content/Swarm/quickstart.user_tasks.html",l:-1,t:"Swarm user tasks",i:0.0015687529820253,a:"Swarm user tasks This section describes  a number of the common  Swarm  user tasks: "},"12":{y:0,u:"../Content/Swarm/quickstart.start_code_review.html",l:-1,t:"Start a code review",i:0.00222615313582689,a:"If your Helix Server is configured as a commit-edge deployment, and your normal connection is to an edge server, Swarm refuses to start reviews for shelved changes that have not been promoted to the commit server. Within Swarm, this means that the Request Review button does not appear for unpromoted ..."},"13":{y:0,u:"../Content/Swarm/quickstart.edit_reviewers.html",l:-1,t:"Edit the reviewers on a review",i:0.0015687529820253,a:"A review author can edit the reviewers for a review by using the Reviewers Edit   button in the review page  Information panel. Reviewers are able to join or leave reviews, or to change whether their vote is required or optional.  If the review includes content that is part of a project or branch ..."},"14":{y:0,u:"../Content/Swarm/quickstart.dashboard.html",l:-1,t:"Check for code reviews you need to act on",i:0.0015687529820253,a:"The purpose of the dashboard is to allow you to focus on reviews that need to be done, so that other users are not blocked. The dashboard lists  the most recently modified reviews first, and shows your role in the review. Your dashboard is available by clicking My Dashboard in the menu or by ..."},"15":{y:0,u:"../Content/Swarm/quickstart.review_list.html",l:-1,t:"List reviews you are involved with",i:0.0015687529820253,a:"Click Reviews in the main menu.  By default all projects are displayed.  To filter the reviews displayed by project, select  My projects or specific projects from the Project drop down. To select multiple projects, click the projects you want to filter by. By default all reviews are displayed.  To ..."},"16":{y:0,u:"../Content/Swarm/quickstart.code_review_contribute.html",l:-1,t:"Contribute comments or code changes to a code review",i:0.00251490168212026,a:"You can contribute to a code review in the following ways:   Comment on a review  Comment on a review description  Comment on a specific line in a file   Comment on a file in a review Reply to a comment Edit files in a review Comments Comments are the primary feedback mechanism provided by Swarm. ..."},"17":{y:0,u:"../Content/Swarm/quickstart.local_copy.html",l:-1,t:"Get a local copy of the code in a review for evaluation",i:0.00723079533480759,a:"Swarm manages one or more changelists containing shelved copies of all of the files belonging to a specific review. You can unshelve the files to receive a copy of the review\u0027s code, or you can click the  Download .zip  button on the review to download a ZIP archive containing all of the review\u0027s ..."},"18":{y:0,u:"../Content/Swarm/quickstart.fix_non_mergeable.html",l:-1,t:"Fix errors that cannot be merged in a review",i:0.0015687529820253,a:"The problem can occur when you attempt to Commit or Approve and Commit via the Swarm UI and the shelved files are out of date. Helix Swarm cannot currently help with resolving conflicts; you need to use a Helix Server client such as p4 or P4V to resolve conflicts. Resolve via P4 Acquire a  local ..."},"19":{y:0,u:"../Content/Swarm/quickstart.author_change.html",l:-1,t:"Change the author of a review",i:0.0015687529820253,a:"By default you cannot change the author of a review, this option must be enabled by your Swarm administrator. See  Allow author change  for details.   If the author of a review is no longer available, or ownership of a review is passed to a different developer, it is useful to be able to change the ..."},"20":{y:0,u:"../Content/Swarm/quickstart.user_notifications.html",l:-1,t:"Change your user notification settings",i:0.0015687529820253,a:"Change your user notification settings Click on your userid in the header and select My Profile. Click the Notifications tab to display your user notifications settings. Configure which notifications you receive when events occur within Swarm, see the  Notifications tab . "},"21":{y:0,u:"../Content/Swarm/quickstart.unfollow_all.html",l:-1,t:"Unfollow all projects and users you are following",i:0.0015687529820253,a:"When you are viewing your own user profile, you can unfollow all projects and users that you are following.  This action cannot be undone. Display your own user profile when you are logged into Swarm by clicking on your userid in the header and selecting My Profile. Your user page is displayed:  ..."},"22":{y:0,u:"../Content/Swarm/quickstart.admin_tasks.html",l:-1,t:"Swarm administration tasks",i:0.0015687529820253,a:"Swarm administration tasks This section describes  a number of the common  Swarm administration tasks:"},"23":{y:0,u:"../Content/Swarm/quickstart.group_notifications.html",l:-1,t:"Change notification settings for a group",i:0.0015687529820253,a:"You must be an owner of the group, have super privileges in Helix Server (p4d), or have admin privileges in p4d version 2012.1 or later, to edit group notifications. If you do not have sufficient permissions, Swarm does not display the Notifications tab for the group. Click Groups in the main menu.  ..."},"24":{y:0,u:"../Content/Swarm/quickstart.manage_branches.html",l:-1,t:"Manage project branches",i:0.00272832743557281,a:"Initial steps: Visit your project page. Click Edit. Next to the Branches label, a drop-down button for each branch is displayed, and + Add Branch. Adding a branch Follow the  initial steps . Click + Add Branch to display the branch drop-down dialog.\n\t\t\t Enter a short Name for your branch. Optional ..."},"25":{y:0,u:"../Content/Swarm/quickstart.unfollow_all_admin_super_user.html",l:-1,t:"Unfollow all projects and users for another user",i:0.0015687529820253,a:"You must be logged in as a user with admin or super user privileges and viewing the user\u0027s profile page to perform this action.  When a user has been removed from the Helix Server but they are still following projects and users, it is useful to be able to remove all of their follows. This helps to ..."},"26":{y:0,u:"../Content/Swarm/quickstart.review_obliterate.html",l:-1,t:"Obliterate a review",i:0.0015687529820253,a:"By default, you must be a user with admin or super user rights to obliterate a review.  Optional: Swarm can be configured to allow users to obliterate reviews that they have authored. Configured by your Swarm administrator, see  Allow author obliterate review .  Obliterate is used to permanently ..."},"27":{y:0,u:"../Content/Swarm/quickstart.logging_level.html",l:-1,t:"Change the logging level",i:0.0015687529820253,a:"Swarm logs various activities to the data/log file. Change the logging level to increase or decrease the volume of log data by editing a configuration file. An example configuration, in the  SWARM_ROOT/data/config.php file: \u003c?php\n\t// this block should be a peer of \u0027p4\u0027\n\t\u0027log\u0027 =\u003e array(\n\t    ..."},"28":{y:0,u:"../Content/Swarm/quickstart.workers.html",l:-1,t:"Check the queue workers",i:0.00218898219110369,a:"Swarm package and OVA installations are automatically configured with a cron job to spawn workers when you run the configure-swarm.sh post-installation configuration script during installation.  Swarm tarball installations should be setup with a cron job to ensure that workers are running to process ..."},"29":{y:0,u:"../Content/Swarm/quickstart.review_deployment.html",l:-1,t:"Automatically deploy code within a review",i:0.00423041555959411,a:"Deploying code in a code review automatically involves enabling Automated Deployment in your project\u0027s configuration and providing a trigger URL. When the trigger URL is requested, Swarm expects a deployment program to be executed. When the deployment processing ends, Swarm expects either a success ..."},"30":{y:0,u:"../Content/Swarm/chapter.setup.html",l:-1,t:"Install and upgrade Swarm",i:0.00227126369954523,a:"This chapter covers the initial installation and configuration of Swarm as well as upgrading an existing Swarm installation.  Important restrictions Do not prefix   group names, project names,  user names, or client-names with \"swarm-\", this is a reserved term  used by Swarm. Prefixing a name with ..."},"31":{y:0,u:"../Content/Swarm/setup.dependencies.html",l:-1,t:"Runtime dependencies",i:0.0171507770979357,a:"In order to successfully install, configure, and deploy Swarm, the following dependencies are required: A recommended operating system, see  Recommended operating systems An Apache server with the modules required by Swarm installed, see  Apache web server A supported version of PHP with the modules ..."},"32":{y:0,u:"../Content/Swarm/chapter-setup_package.html",l:-1,t:"Install and configure Swarm from a package (recommended)",i:0.00387064846505822,a:"This chapter covers the initial installation and configuration of Swarm from a package. Helix Swarm is available in two distribution package formats: Debian (.deb) for Ubuntu systems and  RPM  (.rpm) for CentOS, RedHat \n\t\tEnterprise Linux (RHEL), and Amazon Linux 2.  Using distribution packages ..."},"33":{y:0,u:"../Content/Swarm/setup-packages_ubuntu.html",l:-1,t:"Install and configure Swarm on Ubuntu",i:0.00218898219110369,a:"Swarm is available as a package for Ubuntu 18.04 LTS and 20.04 LTS. Using distribution packages greatly simplifies the installation, updating, and removal of software, as the tools that manage these packages are aware of the\n\t\t dependencies for each package. We recommend that the latest stable ..."},"34":{y:0,u:"../Content/Swarm/setup-package_centos-rhel.html",l:-1,t:"Install and configure Swarm on CentOS/RHEL",i:0.0037538372177781,a:"Swarm packages can be used to install Swarm on CentOS 7, RHEL 7, and RHEL 8. Using packages greatly simplifies the installation, updating, and removal of software, because the tools that manage packages are aware of the\n\t\t dependencies for each package.  CentOS: We recommend that the latest point ..."},"35":{y:0,u:"../Content/Swarm/setup-amazon-linux-packages.html",l:-1,t:"Install and configure Swarm on Amazon Linux 2",i:0.00467877501780717,a:"Swarm packages can be used to install Swarm on Amazon Linux 2. Using packages greatly simplifies the installation, updating, and removal of software, because the tools that manage packages are aware of the\n\t\t dependencies for each package.  We recommend that the latest stable release of Amazon Linux ..."},"36":{y:0,u:"../Content/Swarm/setup.ova.html",l:-1,t:"Deploy and configure a Swarm VM from an OVA",i:0.00860504478243342,a:"Swarm is available as an OVA (Open Virtualization Appliance) that requires minimal configuration. Use the Swarm OVA if you want to: Simplify the installation and configuration steps Experiment with Swarm without using additional hardware Install Swarm without having a Linux-based server available ..."},"37":{y:0,u:"../Content/Swarm/setup.installation.html",l:-1,t:"Install and configure Swarm manually from a Tarball",i:0.00175525370120455,a:"Review the runtime dependencies before you install Swarm, see  Runtime dependencies .  CentOS/RHEL 7: Use the   Remi repository configuration package (remi-release-7.rpm) to give Swarm access to PHP 7.x. Use the epel-release-latest-7.noarch.rpm repository configuration package to give Swarm access ..."},"38":{y:0,u:"../Content/Swarm/setup.redis.html",l:-1,t:"Redis  configuration",i:0.00416576641801055,a:"Swarm requires Redis to manage its caches and by default Swarm uses its own Redis server  on the Swarm machine. Swarm caches data from the Helix Server to improve  the performance of common searches in Swarm and to reduce the load on the Helix Server.  Redis is included in the Swarm Tarball ..."},"39":{y:0,u:"../Content/Swarm/setup.apache.html",l:-1,t:"Apache configuration",i:0.00704776293017563,a:"The configuration of the Apache HTTP Server (Apache) can vary between OS distributions; see the documentation specific to your installation of Apache. For example, on Mac OS X, you may have to enable Web Sharing within the Sharing control panel in System Preferences.  CentOS/RHEL only: Swarm 2019.1 ..."},"40":{y:0,u:"../Content/Swarm/setup_php.html",l:-1,t:"PHP configuration",i:0.0131313471143181,a:"PHP can vary between OS distributions; see the documentation specific to your installation of PHP. First determine which PHP .ini file is in use by the PHP Apache module.  It may not necessarily be the same .ini file that is in use when calling PHP from the command line (running php --ini from the ..."},"41":{y:0,u:"../Content/Swarm/setup.swarm.html",l:-1,t:"Swarm configuration",i:0.0144919137880612,a:"Now that Swarm is ready for use, you need to configure it to work in your environment. Swarm does not support Helix Servers configured to use P4AUTH, see  Centralized authentication server (P4AUTH)  in the  Helix Core Server Administrator Guide . Swarm can be connected to  Helix Servers (P4D) and ..."},"42":{y:0,u:"../Content/Swarm/chapter-extension-trigger-install.html",l:-1,t:"Configuring Helix Core Server event notification",i:0.0015687529820253,a:"Triggers are still supported, but we recommend you use Helix Server Extensions. Helix Server Extensions are easier to install and maintain than Triggers.  Swarm needs to know about a number of Helix Server events to operate correctly, this can be done by using Helix Server Extensions (recommended) ..."},"43":{y:0,u:"../Content/Swarm/setup-extensions.html",l:-1,t:"Installing the Swarm Helix Server extension (recommended)",i:0.00334541766396303,a:"If you are using the Swarm Helix Server extension, Swarm Helix Server Triggers must not be installed. You must be a user with super user permissions to install and configure Helix Server Extensions.  Swarm needs to know about a number of Helix Server events to operate correctly, this is done by ..."},"44":{y:0,u:"../Content/Swarm/setup.perforce.html",l:-1,t:"Installing Triggers",i:0.0143630326149829,a:"If you are using Swarm Helix Server Triggers, the Swarm Helix Server extension must not be installed. Swarm does not support Helix Servers configured to use P4AUTH, see  Centralized authentication server (P4AUTH)  in the  Helix Core Server Administrator Guide . Swarm can be connected to  Helix ..."},"45":{y:0,u:"../Content/Swarm/setup.worker.html",l:-1,t:"Set up a recurring task to spawn workers",i:0.0134959847200821,a:"To ensure that incoming Helix Server events are automatically processed by Swarm, it is important to set up a cron job to do this. We recommend that the cron job is installed on the Swarm host machine.  Install curl or wget You must install either curl or wget  on the Swarm server machine to run the ..."},"46":{y:0,u:"../Content/Swarm/setup_common_steps.html",l:-1,t:"Common post-installation options",i:0.0015687529820253,a:"Common post-installation options This chapter covers the post-installation options that are common for all installation processes. "},"47":{y:0,u:"../Content/Swarm/setup.post.html",l:-1,t:"Post-install configuration options",i:0.0118284176681378,a:"There are a few options for customizing your Swarm installation\u0027s operation. This section covers the options that are officially supported. This section contains:  No customization required Back up your Swarm virtual host first HTTPS Run Swarm in a sub-folder of an existing web site Run the Swarm ..."},"48":{y:0,u:"../Content/Swarm/setup.validate_install.html",l:-1,t:"Validate your Swarm installation",i:0.00325945970307057,a:"When Swarm starts it verifies the Redis cache, during this time you cannot log in to Swarm. The time taken to verify the Redis cache depends on the number of users, groups, and projects Swarm has. Start-up time can be improved by persisting the memory cache. You can persist the memory cache by ..."},"49":{y:0,u:"../Content/Swarm/chapter-setup-upgrade.html",l:-1,t:"Upgrading Swarm",i:0.00282314357730093,a:"The section describes how to upgrade a  Swarm package, OVA, or tarball installation to a newer release.  If you are not already running Swarm, none of these instructions apply to you. Instead, see the  Swarm installation instructions . Choose your  upgrade process:  Upgrading  a  Ubuntu package ..."},"50":{y:0,u:"../Content/Swarm/setup-upgrade-package_ubuntu.html",l:-1,t:"Upgrading  a  Ubuntu package installation",i:0.00485041556981965,a:"The section describes how to upgrade a  Swarm Ubuntu package installation to a newer release.  Swarm runtime dependencies change between releases, you must check that your system satisfies the Swarm runtime dependencies before starting the upgrade, see  Runtime dependencies .  Review the ..."},"51":{y:0,u:"../Content/Swarm/setup-upgrade-package_centos-rhel.html",l:-1,t:"Upgrading a CentOS/RHEL package installation",i:0.00562160068093957,a:"The section describes how to upgrade a  Swarm CentOS/RHEL package installation to a newer release.  Swarm runtime dependencies change between releases, you must check that your system satisfies the Swarm runtime dependencies before starting the upgrade, see  Runtime dependencies .  Review the ..."},"52":{y:0,u:"../Content/Swarm/setup-upgrade_tarball.html",l:-1,t:"Upgrading a tarball installation",i:0.00383319853223797,a:"The section describes how to upgrade a  Swarm tarball installation to a newer release.  The following process attempts to minimize downtime, but a short period of downtime for Swarm users is unavoidable. There should be no downtime for your Helix Server. After a successful upgrade, all Swarm users ..."},"53":{y:0,u:"../Content/Swarm/setup-move.html",l:-1,t:"Moving your Swarm instance",i:0.00175525370120455,a:"This section describes how to move your Swarm instance to another server. This can be useful if you want to move Swarm to a different server to improve performance or if you want to run Swarm on a newer operating system. Swarm data is held on the Helix Core Server and not in Swarm so there is no ..."},"54":{y:0,u:"../Content/Swarm/chapter.basics.html",l:-1,t:"Basics",i:0.00167132798942156,a:"Basics This chapter covers the basic operations provided by Swarm. These include:"},"55":{y:0,u:"../Content/Swarm/basics.dashboard.html",l:-1,t:"My Dashboard",i:0.00193799529055193,a:"The purpose of the dashboard is to allow you to focus on reviews that need to be done, so that other users are not blocked. The dashboard lists  the most recently modified reviews first, and shows your role in the review. Your dashboard is available by clicking My Dashboard in the menu or by ..."},"56":{y:0,u:"../Content/Swarm/basics-global_dashboard.html",l:-1,t:" Global Dashboard",i:0.00506133960391332,a:" Global Dashboard Global Dashboard is only available if your Swarm administrator has configured Swarm to connect to more than one Helix Server instance. For instructions on how to configure Swarm to connect to multiple-Helix Server instances, see  Multiple-Helix Server instances .  Your Global ..."},"57":{y:0,u:"../Content/Swarm/basics.activity_streams.html",l:-1,t:"Activity",i:0.00513580964542123,a:"Activity streams are also shown on the  User ,  Group , and  Project  pages. These activity pages show the activity for the user, project, or group you are viewing.  An activity stream displays a list of events that have occurred recently in the associated Helix Server.  For example, an event is ..."},"58":{y:0,u:"../Content/Swarm/basics.files.html",l:-1,t:"Files",i:0.00327368219619135,a:"Helix Server\u0027s primary task is to version files, so Swarm makes it easy to browse the  depot . Start browsing by clicking Files in the menu. Swarm displays a list of breadcrumb links to help you quickly navigate to higher level directories quickly.  Links with folder icons represent directories of ..."},"59":{y:0,u:"../Content/Swarm/basics.commits.html",l:-1,t:"Commits",i:0.00349386089183748,a:"Whenever a new version of a file is checked into the Helix Server, a commit record is created. Begin browsing the history of commits by clicking Commits in the menu. When you are viewing a particular file or directory, clicking the Commits tab displays the commits for that location in the depot. ..."},"60":{y:0,u:"../Content/Swarm/basics.jobs.html",l:-1,t:"Jobs",i:0.00317634019665164,a:"Jobs  are a component of Helix Server\u0027s defect tracking system and a record of bugs found or improvement requests. Jobs can be associated with  changelists  to create fix records, indicating the work that solved the problem or provided the requested feature. Begin browsing jobs by clicking Jobs in ..."},"61":{y:0,u:"../Content/Swarm/basics.changelists.html",l:-1,t:"Changelists",i:0.00453029326938384,a:"Changelists are the basic unit of versioning work in Helix Core Server. A changelist is a list of files, their revision numbers, and the changes made to those files. Commits is a shorter synonym used throughout Swarm. More information is available here: Browsing changelists Browsing a user\u0027s shelved ..."},"62":{y:0,u:"../Content/Swarm/basics.diffs.html",l:-1,t:"Diffs",i:0.00668239815652408,a:"Code review page The information on this page only applies to the original Swarm Code review page. For information about diffs on the new review page, see  Files tab . To switch between the original review page and the review page preview, use the Preview toggle switch at the top of the review page. ..."},"63":{y:0,u:"../Content/Swarm/basics.comments.html",l:-1,t:"Comments",i:0.0110140194200895,a:"Comments are the primary feedback mechanism provided by Swarm. Review comments can be flagged as  tasks for a lightweight workflow within a review that helps authors and reviewers prioritize review feedback, see  Tasks  for details. By default, comment notifications are delayed to allow you to add ..."},"64":{y:0,u:"../Content/Swarm/basics.users.html",l:-1,t:"Users",i:0.00957259373787178,a:"Swarm\u0027s users are based on the users configured in the Helix Server.  Viewing your user profile Viewing another user\u0027s profile Viewing  another user\u0027s profile when you have admin or super user privileges Viewing your user profile Display your own user profile when you are logged in by clicking on ..."},"65":{y:0,u:"../Content/Swarm/basics.groups.html",l:-1,t:"Groups",i:0.00953948094927158,a:"Groups are a feature of Helix Server that makes it easier to manage permissions for users. It is important to be aware of certain aspects of Helix Server groups: Groups can have both users and sub-groups. A user that is a member of a sub-group is also a member of the parent group. Groups have ..."},"66":{y:0,u:"../Content/Swarm/basics.projects.html",l:-1,t:"Projects",i:0.00931076307637642,a:"A Swarm project  is made up of a group of Helix Server users  who are working together on one or more codelines within the Helix Server. A project\u0027s definition includes one or more branches of code, and optionally a  job  filter,  automated test integration , and  automated deployment . This section ..."},"67":{y:0,u:"../Content/Swarm/basics.workflows.html",l:-1,t:"Workflows",i:0.00229761986599917,a:"Workflow is enabled by default and can be disabled by your Swarm administrator, see  workflow  . A workflow can be applied to a  project  or  project branch to ensure that changelists and code reviews in the project/branch follow the rules specified in that workflow.  Swarm workflows can be created ..."},"68":{y:0,u:"../Content/Swarm/basics_wip_tag.html",l:-1,t:"Work-in-progress tag",i:0.00631140613238493,a:"Add the work-in-progress tag (#wip by default) to a pending changelist description to tell Swarm that your work is not ready to be reviewed yet. For example, when changes are requested for a review, and you want to address them in stages but get them all reviewed once your work is complete. When you ..."},"69":{y:0,u:"../Content/Swarm/basics_tests.html",l:-1,t:"Tests",i:0.00231787984081226,a:"The Tests page is only available if Workflow is enabled, workflow is enabled by default.  Associate a test with a  workflow  to ensure that the test is run when a review associated with that workflow is started or updated. Associate a test with the  global workflow  to ensure that the test is run ..."},"70":{y:0,u:"../Content/Swarm/basics.notifications.html",l:-1,t:"Notifications",i:0.0116597262958865,a:"Provided you have entered a working email address for your userid in Helix Server, Swarm sends email notifications to you when various events take place. The table below shows the notifications sent if all of the project, group, and user notifications are enabled. This is the default behavior.  The ..."},"71":{y:0,u:"../Content/Swarm/basics.login_logout.html",l:-1,t:"Log in/Log out",i:0.00545612301520774,a:"When you are not logged into Swarm, certain features are unavailable to you, such as providing comments to changes or reviews, adding projects, and more. Log in to Swarm Click Log in on the right of the Swarm header. Single Sign-On (SSO) If Helix Authentication Service is configured for your Helix ..."},"72":{y:0,u:"../Content/Swarm/basics.notable.html",l:-1,t:"Notable minor features",i:0.0152716306785791,a:"Quick URLs Swarm handles URLs intelligently to reduce the amount of information you need to enter to quickly locate what you are looking for:  Enter a URL in the following format: https://myswarm.url/\u003cidentifier\u003e Swarm checks the \u003cidentifier\u003e and redirects you to the first match it finds. Swarm ..."},});