define({"73":{y:0,u:"../Content/Swarm/basics.markdown.html",l:-1,t:"Markdown",i:0.00450712125102292,a:"You can use  Markdown  to add text styles to comments, review descriptions, and project overview pages. Swarm can also display Markdown files  stored in the Helix Core Server.  The  Review Activity  tab is rendered in GFM (Git Flavored Markdown).  The  User ,  Group , and  Project  page Activity ..."},"74":{y:0,u:"../Content/Swarm/chapter.code_reviews.html",l:-1,t:"Code reviews",i:0.00214858858188898,a:"A code review is a process in which other developers can see your code and provide feedback that can suggest ways to improve the code\u0027s structure, performance, maintainability, and interaction with other code. Benefits Some of the benefits of code review are: Enforcing coding standards: code reviews ..."},"75":{y:0,u:"../Content/Swarm/code_reviews.model.html",l:-1,t:"Models",i:0.0151390049300747,a:"There are two code review models: pre-commit and post-commit. Which model you use for code reviews with Swarm is up to you. Pre-commit model The pre-commit model is possible due to Helix Server\u0027s shelving feature. Shelving enables you to temporarily make copies of your files available to other users ..."},"76":{y:0,u:"../Content/Swarm/code_reviews.list.html",l:-1,t:"Reviews list",i:0.00665598027759722,a:"The code review list helps you keep track of code reviews that: Have been requested and are awaiting review Are underway Have been accepted, rejected, or archived To see all available reviews, click Reviews in the menu. The Reviews page lists open and closed reviews for all projects in the Helix ..."},"77":{y:0,u:"../Content/Swarm/code_reviews.display.html",l:-1,t:"Review display",i:0.0149918812941536,a:"The new Swarm review page is now available as a preview. The new Swarm review page is described in this documentation.  By default, Swarm opens the original  review page when you first start Swarm 2022.1. To access the review page preview, use the Preview toggle switch at the top of the review page. ..."},"78":{y:0,u:"../Content/Swarm/code_reviews.activities.html",l:-1,t:"Activities",i:0.00998446687328925,a:"This section describes the major activities that affect code reviews, including starting a review, updating a review, and fetching a review\u0027s files. Start a review If your Helix Server is configured as a commit-edge deployment, and your normal connection is to an edge server, Swarm refuses to start ..."},"79":{y:0,u:"../Content/Swarm/code_reviews.add_changelist.html",l:-1,t:"Add a changelist to a review",i:0.00222615313582689,a:"Once a review has been started you can add a changelist to the review. It can be useful to add changelists to an existing review. For example, if follow up changes are made to files in a review or if you need to group a number of changelists under a single review.   The Add change option in the ..."},"80":{y:0,u:"../Content/Swarm/code_reviews.responsibility.html",l:-1,t:"Responsibility",i:0.00696036938441098,a:"Initially, code reviews have no reviewers.  User and group default reviewers can be set for individual projects and project branches. Each time a new review is created in the project or project branch, the default reviewers will be added to the review. See  default reviewers  for details.  Users can ..."},"81":{y:0,u:"../Content/Swarm/code_reviews.workflow.html",l:-1,t:"Review workflow",i:0.00552858152281339,a:"There are many possible code review workflows. The section describes typical scenarios for a code review that Swarm can handle. Basic review workflow This section describes a basic workflow when reviewing code with Swarm.  Another developer reviews your code You request a code review with a shelved ..."},"82":{y:0,u:"../Content/Swarm/code_reviews.states.html",l:-1,t:"States",i:0.00617602680724484,a:"Reviews can be in one of several states. The biggest differentiator is whether the review\u0027s files have any outstanding, uncommitted changes or not. Whenever a review state changes, an email notification is sent to all review participants, including: The review author Any user who comments on the ..."},"83":{y:0,u:"../Content/Swarm/chapter.group.html",l:-1,t:"Groups",i:0.0030028109690697,a:"Groups are a feature of Helix Server that makes it easier to manage permissions for users. Swarm can use groups to coordinate review activities and responsibilities. This chapter covers how to manage groups in Swarm, including how to: Add a group Edit a group Delete a group See  Groups  for an ..."},"84":{y:0,u:"../Content/Swarm/groups.add.html",l:-1,t:"Add a group",i:0.00886167571020403,a:"You must have super privileges in Helix Server (p4d), or have admin privileges in p4d version 2012.1 or later, to create a group. If you do not have sufficient permissions, Swarm does not display the Add Group button. To view a list of groups, click Groups in the menu. Click the + Add Group button. ..."},"85":{y:0,u:"../Content/Swarm/groups.edit.html",l:-1,t:"Edit a group",i:0.00220687556322472,a:"You must be an owner of the group, or be a user with super privileges in Helix Server, to edit the group. Visit the group page you want to edit. Click the Settings tab for the group to edit group details. If you do not have permission to edit a group, this tab does not appear. Edit group details as ..."},"86":{y:0,u:"../Content/Swarm/groups.delete.html",l:-1,t:"Delete a group",i:0.00220687556322472,a:"You must be an owner of the group, or be a user with super privileges in Helix Server, to delete the group. Visit the group page you want to delete. Click the Settings tab for the group. If you do not have permission to edit a group, this tab does not appear. Click Delete. A tooltip is displayed to ..."},"87":{y:0,u:"../Content/Swarm/chapter.projects.html",l:-1,t:"Projects",i:0.00213407518235153,a:"A Swarm project  is a group of Helix Server users who are working together on a specific codebase, defined by one or more branches of code, along with a  job  filter, and automated test integration. This chapter covers Swarm\u0027s project management capabilities, including how to: Add a project Edit a ..."},"88":{y:0,u:"../Content/Swarm/projects.add.html",l:-1,t:"Add a project",i:0.0102670098622688,a:"On the Swarm Projects page, click the + Add Project button. The ability to add projects can be  limited to administrators only , or  limited to members of specific groups . When limited, users who are not administrators, or a member of the specified group, will not see the + Add Project button. The ..."},"89":{y:0,u:"../Content/Swarm/projects.edit.html",l:-1,t:"Edit a project",i:0.00193155798728176,a:"Visit the project page you want to edit. Click Settings in the project menu. Edit the project\u0027s details as required. See  Add a project  for more details. If sharing is switched off for a workflow, any projects or branches that were associated with the workflow while it was shared will remain ..."},"90":{y:0,u:"../Content/Swarm/projects.membership.html",l:-1,t:"Membership",i:0.00599751865555983,a:"Membership in a Swarm project identifies users as belonging to the project, making them part of the team. The are only a few notable differences between project members and non-members: There are two ways to become a member of a project in Swarm: Add a project and make yourself a member. Ask a ..."},"91":{y:0,u:"../Content/Swarm/projects.delete.html",l:-1,t:"Delete a project",i:0.00193155798728176,a:"Users with super or admin privileges in Helix Server can delete projects. Project owners can delete projects that they own. If a project has no owners, any member of the project can delete the project.  When you delete a project: The deleted project is removed from the Swarm project list on the ..."},"92":{y:0,u:"../Content/Swarm/chapter.workflows.html",l:-1,t:"Workflows",i:0.00575682518712751,a:"This chapter covers Swarm workflow management, including: Why should I use Swarm workflow? Workflow overview Add a workflow Edit a workflow Delete a workflow Related information:  For  instructions on how to  list, search, and view workflows, see  Workflows .  For instructions on how to add a ..."},"93":{y:0,u:"../Content/Swarm/workflow_why_use_it.html",l:-1,t:"Why should I use Swarm workflow?",i:0.00269140439451007,a:"By default Swarm\u0027s review process is basically advisory in nature with very few restrictions imposed on the review process. Team members can work in whatever way they want,  but as projects grow in size and complexity, teams may prefer a stricter set of workflow rules over flexibility in order to ..."},"94":{y:0,u:"../Content/Swarm/workflow.overview.html",l:-1,t:"Workflow overview",i:0.00544848794115472,a:"For Swarm 2019.2 and later, the workflow feature is enabled by default. If the workflow feature is not working, ask your Swarm administrator to check that the workflow prerequisites have been met, see  Workflow prerequisites . The Swarm administrator can give individual groups and users special ..."},"95":{y:0,u:"../Content/Swarm/workflow.add.html",l:-1,t:"Add a workflow",i:0.00961353905402173,a:"Swarm workflows can be created by any Swarm user. Shared Swarm workflows can be viewed  by any Swarm user.  Shared Swarm workflows can be  applied to a project or project branch by any Swarm user that is authorized to  edit the project. The  global workflow can be viewed by any Swarm user but can ..."},"96":{y:0,u:"../Content/Swarm/workflow.edit.html",l:-1,t:"Edit a workflow",i:0.00211247660457411,a:"Changes made to a workflow will change the workflow for projects and project branches that use that workflow.  A workflow can only be edited by the owner of the workflow or a user with super user rights.  To edit the Global Workflow, see  Workflow global rules .  Visit the Workflow page you want to ..."},"97":{y:0,u:"../Content/Swarm/workflow.delete.html",l:-1,t:"Delete a workflow",i:0.0025030847052092,a:"A workflow can only be deleted by the owner of the workflow, or a user with super user rights. The Global Workflow cannot be deleted. To delete a workflow: Navigate to the workflow you want to delete. Make sure that there are no projects, or branches associated with the workflow.  If  projects, or ..."},"98":{y:0,u:"../Content/Swarm/chapter_tests.html",l:-1,t:"Tests",i:0.00470496125419371,a:"The Tests page is only available if Workflow is enabled, workflow is enabled by default.  This chapter covers Swarm test management, including: Add a test Edit a test Delete a test To add a test to a workflow, see  Add a workflow . Related information:  For  instructions on how to  list, search, and ..."},"99":{y:0,u:"../Content/Swarm/test-add.html",l:-1,t:"Add a test",i:0.00669168465868232,a:"Swarm tests can be created by any Swarm user. Shared Swarm tests can be viewed  by any Swarm user.  Shared Swarm tests can be  added to a workflow by any Swarm user that is authorized to  edit the workflow.  Shared Swarm tests can be added to the global workflow by any Swarm user that is authorized ..."},"100":{y:0,u:"../Content/Swarm/test-edit.html",l:-1,t:"Edit a test",i:0.00262936312897963,a:"Edit a test Changes made to a test will change the test for workflows that use it.  A test can only be edited by the owner of the test or a user with super user rights.  Navigate to the Test page you want to edit.  Edit the test details as required, see  Add a test  for more details. Click Save."},"101":{y:0,u:"../Content/Swarm/test-delete.html",l:-1,t:"Delete a test",i:0.00262936312897963,a:"A test can only be deleted by the owner of the test or a user with super user rights. To delete a test: Navigate to the test you want to delete. Make sure that there are no workflows associated with the test.  If workflows are associated with the test, the Delete button is disabled, and the test ..."},"102":{y:0,u:"../Content/Swarm/chapter.integrations.html",l:-1,t:"Integrations",i:0.00259487998302984,a:"Swarm integrates with a variety of other applications and processes to provide important functionality, such as automated testing and deployment of code in reviews, issue tracking, file previewing, and downloading archives. This chapter describes each of the integrations available with Swarm. ..."},"103":{y:0,u:"../Content/Swarm/integrations.jira.html",l:-1,t:"Jira",i:0.00441233932952793,a:"Swarm\u0027s Jira integration allows code reviews and committed changes to be associated with Jira issues, making it easy to reference associated issues, and see the state of a code review or committed change within Jira. To associate a code review with a Jira issue, include a Jira issue identifier in ..."},"104":{y:0,u:"../Content/Swarm/integrations.libreoffice.html",l:-1,t:"LibreOffice",i:0.00345535897900618,a:"LibreOffice is a free power-packed open source personal productivity suite. When LibreOffice is installed on the server hosting Swarm, Swarm automatically detects its presence and uses LibreOffice to prepare PDF previews of a variety of file types, including: Word documents (.doc, .docx) PowerPoint ..."},"105":{y:0,u:"../Content/Swarm/admin.archives.html",l:-1,t:"Zip archive",i:0.00310343100869419,a:"When the zip command-line tool is installed on the Swarm server, Swarm allows users to download  ZIP archives of files and folders. You can download a Zip archive using the Download zip option from the following Swarm pages:  Review display  page.  Changelists  page.  Files  page. Installation ..."},"106":{y:0,u:"../Content/Swarm/chapter.administration.html",l:-1,t:"Administration",i:0.00167132798942156,a:"This section covers administration and configuration of Swarm. If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super user to reload the Swarm config cache. Navigate to ..."},"107":{y:0,u:"../Content/Swarm/admin.deploy_review.html",l:-1,t:"Automated deployment for reviews",i:0.00193637372482003,a:"Deploying code in a code review automatically involves enabling Automated Deployment in your project\u0027s configuration and providing a trigger URL. When the trigger URL is requested, Swarm expects a deployment program to be executed. When the deployment processing ends, Swarm expects either a success ..."},"108":{y:0,u:"../Content/Swarm/admin.integrate_test_suite.html",l:-1,t:"Automated testing for reviews",i:0.0053090545595805,a:"From Swarm 2020.1, the preferred method for defining tests is on the Swarm Tests  page. This enables you to:  Associate a test with a  workflow  to ensure that the test is run when a review associated with that workflow is either created/updated or submitted.  Associate a test with the  global ..."},"109":{y:0,u:"../Content/Swarm/admin.avatars.html",l:-1,t:"Avatars",i:0.00161435852687448,a:"Swarm uses avatars, images that represent users and groups responsible for events in activity streams, projects, reviews, etc. Avatars are retrieved from an avatar provider; the default provider is  gravatar.com . Swarm sends an identifier to the avatar provider (for gravatar.com, an MD5 hash of the ..."},"110":{y:0,u:"../Content/Swarm/admin.backup.html",l:-1,t:"Backups",i:0.0015687529820253,a:"Swarm stores all of the information it requires to operate within the Helix Server. This includes project definitions, code reviews, comments, followers, and more. Code reviews are largely built on top of Helix Server\u0027s shelving feature, and most other records are stored in custom counters called ..."},"111":{y:0,u:"../Content/Swarm/admin.changelist_files.html",l:-1,t:"Changelist files limit",i:0.00174573573153583,a:"Changelists or reviews with many files present a challenge to Swarm; it can take a notable amount of time for the file listing to reach Swarm from the Helix Server, and a notable amount of time to provide the file listing HTML to a user\u0027s browser. When the file listing is many thousands of files, ..."},"112":{y:0,u:"../Content/Swarm/admin.client_integration.html",l:-1,t:"Client integration",i:0.00884949936155164,a:"P4V and P4VS can integrate with Swarm. To indicate how these applications should connect with Swarm, Swarm sets the P4.Swarm.URL property set in Helix Server. P4V and P4VS read this property, and if set, they connect to the specified URL to make Swarm API calls. If the property is unset, Swarm ..."},"113":{y:0,u:"../Content/Swarm/admin.comment_attachments.html",l:-1,t:"Comment attachments",i:0.00575576288100614,a:"Swarm supports attaching arbitrary files to comments in code reviews and jobs. If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super user to reload the Swarm config ..."},"114":{y:0,u:"../Content/Swarm/admin.comment_mentions.html",l:-1,t:"Comment mentions",i:0.00628152136340434,a:"This section describes how to customize how Swarm treats user @mentions and group @@mentions in auto-complete drop-downs, comments, changelists, and review descriptions.  @mentions for users is only available for Swarm 2017.1 and later. @@mentiions for groups is only available for Swarm 2017.3 and ..."},"115":{y:0,u:"../Content/Swarm/admin.comments.html",l:-1,t:"Comments",i:0.00434134069058686,a:"This section provides information on how to delay comment notifications, and configure comment threading.  If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super user ..."},"116":{y:0,u:"../Content/Swarm/admin.commit_credit.html",l:-1,t:"Commit credit",i:0.0020916191193419,a:"When you use Swarm to commit a review, but you are not the review\u0027s author, Swarm gives credit to the review author by default. Activity stream entries and email notifications include both the committer and review author\u0027s details. If you make a configuration change, Swarm will not use it until the  ..."},"117":{y:0,u:"../Content/Swarm/admin.commit_edge.html",l:-1,t:"Commit-edge deployment",i:0.00403065675501666,a:"Swarm can connect to a Helix Core Server configured to use the commit-edge architecture, which is a specific replication configuration that employs a commit server and one or more edge servers. This configuration distributes the compute, storage, and network requirements for improved performance and ..."},"118":{y:0,u:"../Content/Swarm/admin.commit_timeout.html",l:-1,t:"Commit timeout",i:0.00161435852687448,a:"When a code review contains many files, or large files, or both, committing the review within Swarm can take some time. The default configuration, within the  SWARM_ROOT/data/config.php file: If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, ..."},"119":{y:0,u:"../Content/Swarm/admin.configuration.html",l:-1,t:"Configuration overview",i:0.00230702644298599,a:"This section provides an overview of all the possible configuration blocks in the  SWARM_ROOT/data/config.php file. Click on any link in the configuration overview below to see a detailed description of that configurable. While the syntax of this example is correct, it includes configuration values ..."},"120":{y:0,u:"../Content/Swarm/admin.diffs.html",l:-1,t:"Diff configuration",i:0.00161435852687448,a:"Swarm\u0027s  Diffs  feature can be customized via the following config item. If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super user to reload the Swarm config cache. ..."},"121":{y:0,u:"../Content/Swarm/admin.email.html",l:-1,t:"Email configuration",i:0.00473267733736486,a:"Swarm\u0027s email delivery is controlled by the mail configuration block in the  SWARM_ROOT/data/config.php file.  If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super ..."},"122":{y:0,u:"../Content/Swarm/admin.emoji.html",l:-1,t:"Emoji",i:0.00392859762959799,a:"By default, Swarm uses a font to provide Emoji images. Swarm can make use of Emoji images from the  Gemoji project . Gemoji provides support for more Emojis and works on more browsers and platforms than the font Swarm normally uses. By default, Gemoji is only supplied with a small number of custom ..."},"123":{y:0,u:"../Content/Swarm/admin.environment.html",l:-1,t:"Environment",i:0.013880819145243,a:"This section describes the environment configuration items available for Swarm: mode: whether Swarm operates in production or development mode. hostname: specifies the canonical hostname Swarm should use, such as in links to Swarm in email notifications. external_url: specifies the canonical URL ..."},"124":{y:0,u:"../Content/Swarm/admin.exclude_users.html",l:-1,t:"Excluding Users from Activity Streams",i:0.00161435852687448,a:"Larger Helix Server installations often have one or more service users that perform automated tasks, such as build systems, continuous integration test servers, or integrations with 3rd-party databases via P4DTG. As Swarm reports the activity of users, and these service users can generate ..."},"125":{y:0,u:"../Content/Swarm/admin.files.html",l:-1,t:"Files configuration",i:0.00267862959011134,a:"Swarm can be customized using the following config items: If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super user to reload the Swarm config cache. Navigate to the ..."},"126":{y:0,u:"../Content/Swarm/admin.groups.html",l:-1,t:"Groups configuration",i:0.00266651094504887,a:"By default, Swarm allows all users to see the Groups menu item and use it to view the list of user groups. Users can view the members of a group, as well as their activities. If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm ..."},"127":{y:0,u:"../Content/Swarm/admin.ignored_users.html",l:-1,t:"Ignored users for reviews",i:0.00161435852687448,a:"Automated test environments may inadvertently participate in code reviews if they copy user-generated change descriptions. For example, if an automated system copied a change description containing #review and subsequently shelved or committed files, a new review would be started. Similarly copying ..."},"128":{y:0,u:"../Content/Swarm/admin_linkify_keyword.html",l:-1,t:"Job keywords",i:0.00486017208803168,a:"By default, if you add jobnnnnn or @jobnnnnn to a job description, changelist description,  review description, or comment, Swarm automatically creates a link to the Swarm job page if a match is found. The jobnnnnn or @jobnnnnn keywords are hardcoded in Swarm and always present.  If your job numbers ..."},"129":{y:0,u:"../Content/Swarm/admin.license.html",l:-1,t:"License",i:0.0015687529820253,a:"Helix Swarm has always been free to use with an unlicensed Helix Server. With the 2014.4 release, Swarm is free to use with any Helix Server. You no longer need to purchase a Swarm-specific license, and any existing Swarm-specific licenses are no longer evaluated. An unlicensed Helix Server provides ..."},"130":{y:0,u:"../Content/Swarm/admin.locale.html",l:-1,t:"Localization \u0026 UTF8 character display",i:0.00201189204203565,a:"To ensure that all characters, including Unicode characters, are displayed and handled correctly by Swarm, configure your Helix Server in Unicode mode. For information on configuring your Helix Server in Unicode mode, see  Setting up and managing Unicode installations  in the  Helix Core Server ..."},"131":{y:0,u:"../Content/Swarm/admin.logging.html",l:-1,t:"Logging",i:0.0065437752279412,a:"Helix Swarm is a web application, so there are several types of logging involved during the course of Swarm\u0027s normal operations. If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an ..."},"132":{y:0,u:"../Content/Swarm/admin.mainline.html",l:-1,t:"Mainline branch identification",i:0.0104062199124965,a:"When viewing a project\u0027s files, the initial view is the list of the project\u0027s branches. The branches appear in alphabetical order, but the branch identified as the main branch appears first and in bold. By default, a project overview page is displayed when there is a README Markdown file in the ..."},"133":{y:0,u:"../Content/Swarm/admin.markdown.html",l:-1,t:"Markdown",i:0.00581549515218664,a:"The markdown configurable defines what can be rendered in Markdown by Swarm for project overview pages and files stored in the Helix Core Server. By default, markdown is set to safe, Markdown text is displayed, but Markdown support is limited to prevent execution of raw HTML and JavaScript content.  ..."},"134":{y:0,u:"../Content/Swarm/admin_menu_helper.html",l:-1,t:"Menu helpers",i:0.00570324677410159,a:"The menu_helpers configuration block is used to control the visibility of Swarm menu items and to create new menu items for URLs and Swarm modules.  If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new ..."},"135":{y:0,u:"../Content/Swarm/admin_multiple_p4d_config.html",l:-1,t:"Multiple-Helix Server instances",i:0.00740249952864279,a:"A single Swarm server can be connected one or more Helix Core Server (P4D) instances. This section describes how to configure Swarm to connect to multiple Helix Servers. Issue: Swarm will lose connection to all of the Helix Servers if you edit the  base_url  configurable value in the environment ..."},"136":{y:0,u:"../Content/Swarm/admin.notifications.html",l:-1,t:"Notifications",i:0.00782233496379529,a:"This section describes the configurables that can be set for notifications.  If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super user to reload the Swarm config ..."},"137":{y:0,u:"../Content/Swarm/admin.review_obliterate.html",l:-1,t:"Obliterate Review",i:0.00484714390452726,a:"By default, you must be a user with admin or super user rights to obliterate a review.  Optional: Swarm can be configured to allow users to obliterate reviews that they have authored. Configured by your Swarm administrator, see  Allow author obliterate review .  Obliterate is used to permanently ..."},"138":{y:0,u:"../Content/Swarm/admin.ova.html",l:-1,t:"OVA management",i:0.00400697884558056,a:"The Helix Swarm OVA is installed with Ubuntu 20.04 LTS. Ubuntu\u0027s \"Long-Term Support\" releases receive security updates periodically over their 5-year support window. We recommend you update your OVA packages regularly to make sure you have the latest updates.  To update your OVA packages:  Log in to ..."},"139":{y:0,u:"../Content/Swarm/admin.p4trust.html",l:-1,t:"P4TRUST",i:0.0015687529820253,a:"When Swarm is configured to connect to a Helix Server (P4D) using an SSL connection, Swarm automatically executes the p4 trust command, which accepts the SSL fingerprint and creates a  p4trust file containing a list of trusted servers and their fingerprints. The location the p4trust file is saved to ..."},"140":{y:0,u:"../Content/Swarm/admin.projects.html",l:-1,t:"Projects",i:0.0158950539518856,a:"This section describes the configurables that can be set for projects. If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super user to reload the Swarm config cache. ..."},"141":{y:0,u:"../Content/Swarm/admin.redis.html",l:-1,t:"Redis server",i:0.00648232621989481,a:"Swarm requires Redis to manage its caches and by default Swarm uses its own Redis server  on the Swarm machine. Swarm caches data from the Helix Server to improve  the performance of common searches in Swarm and to reduce the load on the Helix Server.  Redis configuration:  Swarm connection to Redis ..."},"142":{y:0,u:"../Content/Swarm/admin.review_cleanup.html",l:-1,t:"Review cleanup",i:0.00556814954632647,a:"This section describes the configurables that can be set for review cleanup.  If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super user to reload the Swarm config ..."},"143":{y:0,u:"../Content/Swarm/admin.review_keyword.html",l:-1,t:"Review keyword",i:0.00647736078732568,a:"This section describes how to configure keywords, and how to use keywords in a changelist description to create a review, and add a changelist to a review.  If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new ..."},"144":{y:0,u:"../Content/Swarm/admin.review_filter.html",l:-1,t:"Reviews filter",i:0.00296584825989008,a:"This section describes the configurables that can be set for the reviews filter.  If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super user to reload the Swarm config ..."},"145":{y:0,u:"../Content/Swarm/admin.reviews.html",l:-1,t:"Reviews",i:0.0109753583953254,a:"This section describes the configurables that can be set for reviews.  If you make a configuration change, Swarm will not use it until the  configuration cache has been reloaded, this forces Swarm to  use the new configuration. You must be an admin or super user to reload the Swarm config cache. ..."},});